﻿Public Class ActiveProps
    Public Active As Active

    Dim ParamControls As New List(Of Control)

    Private Sub ActiveForm_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown
        Text = "Active $" & Active.ID
        If TypeOf Active Is ActiveA Then
            Text &= " " & DirectCast(Active, ActiveA).Describe.Name
        End If
        Text &= " " & Active.Name

        Dim curY = 12
        Const deltaY = 26

        Me.SuspendLayout()

        For i = 0 To Active.GetNumParams() - 1
            Dim param = Active.GetParam(i)

            Dim label As New Label
            label.AutoSize = False
            label.Text = Active.GetParamName(i) & ":"
            label.Location = New Point(0, curY)
            label.Size = New Size(141, 20)
            label.TextAlign = ContentAlignment.MiddleRight
            Me.Controls.Add(label)

            Select Case param.Definition.Type
                Case ParamType.PT_Float
                    Dim newControl As New NumericUpDown
                    newControl.DecimalPlaces = 6
                    newControl.Minimum = -999999
                    newControl.Maximum = 999999
                    newControl.Location = New Point(147, curY)
                    newControl.Size = New Size(120, 20)
                    newControl.Value = StrToNum(param.Value)
                    newControl.Tag = param
                    Me.Controls.Add(newControl)
                    ParamControls.Add(newControl)
                Case ParamType.PT_String
                    Dim newControl As New TextBox
                    newControl.Location = New Point(147, curY)
                    newControl.Size = New Size(139, 20)
                    newControl.Text = param.Value
                    Select Case param.Definition.Misc
                        Case "l" : newControl.BackColor = Color.FromArgb(255, 255, 192)
                        Case "o" : newControl.BackColor = Color.FromArgb(192, 192, 255)
                        Case "a" : newControl.BackColor = Color.FromArgb(255, 192, 255)
                        Case ""
                        Case Else
                            If 1 Then
                            End If
                    End Select
                    newControl.Tag = param
                    Me.Controls.Add(newControl)
                    ParamControls.Add(newControl)
                Case ParamType.PT_List
                    Dim newControl As New ComboBox
                    newControl.Location = New Point(147, curY)
                    newControl.Size = New Size(139, 20)
                    newControl.DropDownStyle = ComboBoxStyle.DropDownList
                    For Each value In param.Definition.Values
                        newControl.Items.Add(value)
                    Next
                    newControl.SelectedIndex = CInt(param.Value)
                    newControl.Tag = param
                    Me.Controls.Add(newControl)
                    ParamControls.Add(newControl)
                Case ParamType.PT_Flag
                    Dim newControl As New CheckedListBox
                    newControl.Location = New Point(147, curY)
                    newControl.Size = New Size(139, 4 + 15 * param.Definition.Values.Count)
                    Dim data = CInt(param.Value)
                    Dim j = 0
                    For Each value In param.Definition.Values
                        newControl.Items.Add(value)
                        newControl.SetItemChecked(j, (data >> j) And 1)
                        j += 1
                    Next
                    newControl.CheckOnClick = True
                    curY += newControl.Size.Height - 20
                    newControl.Tag = param
                    Me.Controls.Add(newControl)
                    ParamControls.Add(newControl)
            End Select

            curY += deltaY
        Next

        Me.ResumeLayout()

    End Sub

    Private Sub ActiveForm_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        For Each ctrl In ParamControls
            Dim param As ActiveParam = ctrl.Tag
            Select Case param.Definition.Type
                Case ParamType.PT_String
                    param.Value = ctrl.Text
                Case ParamType.PT_Float
                    param.Value = DirectCast(ctrl, NumericUpDown).Value
                Case ParamType.PT_List
                    param.Value = DirectCast(ctrl, ComboBox).SelectedIndex
                Case ParamType.PT_Flag
                    Dim clb = DirectCast(ctrl, CheckedListBox)
                    Dim value = 0
                    For i = 0 To clb.Items.Count - 1
                        If clb.GetItemChecked(i) Then
                            value = value Or (1 << i)
                        End If
                    Next
                    param.Value = value
            End Select
        Next
    End Sub

    Private Sub llHelp_LinkClicked(sender As System.Object, e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles llHelp.LinkClicked
        MessageBox.Show(My.Resources.ActivePropsHelp)
    End Sub
End Class