﻿Public Class ActiveTreeForm
    Public Project As Project

    Private Sub ActiveTreeForm_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown
        MainTreeView.BeginUpdate()
        MainTreeView.Nodes.Clear()
        For Each a In Project.Assets
            If TypeOf a Is Active Then
                Dim aa = DirectCast(a, Active)
                If aa.Visible And aa.Parent Is Nothing Then
                    LoadNode(Nothing, aa)
                End If
            End If
        Next
        MainTreeView.EndUpdate()
    End Sub

    Sub LoadNode(parent As TreeNode, act As Active)
        Dim item As TreeNode
        If parent Is Nothing Then
            item = MainTreeView.Nodes.Add("")
        Else
            item = parent.Nodes.Add("")
        End If

        item.Tag = act

        If TypeOf act Is ActiveA Then
            Dim aa = DirectCast(act, ActiveA)
            item.Text = "$" & act.ID & " " & aa.GetCodeString() & "  " & act.Name
            Select Case aa.Describe.Name
                Case "calculator" : item.ImageIndex = 3
                Case "simple_object" : item.ImageIndex = 2
                Case "delay" : item.ImageIndex = 4
                Case "rotator" : item.ImageIndex = 5
                Case "mover" : item.ImageIndex = 6
                Case "simple_light" : item.ImageIndex = 7
                Case "effect", "hatas" : item.ImageIndex = 8
                Case "upgrade" : item.ImageIndex = 9
                Case "set" : item.ImageIndex = 10
                Case "sound" : item.ImageIndex = 11
                Case "selector" : item.ImageIndex = 12
                Case "generator" : item.ImageIndex = 13
            End Select
        Else
            Dim ab = DirectCast(act, ActiveB)
            Dim str As New System.Text.StringBuilder(50)
            str.Append("$").Append(act.ID).Append(" ").Append(act.Name).Append(" (")
            For i = 0 To ab.ExposedParams.Count - 1
                str.Append(ab.ExposedParams(i).Name)
                If i < ab.ExposedParams.Count - 1 Then str.Append(", ")
            Next
            str.Append(")")
            item.Text = str.ToString
            item.ImageIndex = 1

            For Each child In ab.Children
                LoadNode(item, child)
            Next
        End If
        item.SelectedImageIndex = item.ImageIndex
        item.StateImageIndex = item.ImageIndex

    End Sub

    Private Sub btnEdit_Click(sender As System.Object, e As System.EventArgs) Handles btnEdit.Click, MainTreeView.NodeMouseDoubleClick
        Dim item = MainTreeView.SelectedNode
        If item IsNot Nothing Then
            Dim propsForm As New ActiveProps
            propsForm.Active = item.Tag
            propsForm.ShowDialog(Me)
        End If
    End Sub

    Private Sub btnCopy_Click(sender As System.Object, e As System.EventArgs) Handles btnCopy.Click
        Dim item = MainTreeView.SelectedNode
        If item IsNot Nothing Then
            My.Computer.Clipboard.SetText(item.Text)
        End If
    End Sub

End Class