﻿Public Class LightProps
    Public Light As Light

    Private Sub btnColor_Click(sender As System.Object, e As System.EventArgs) Handles btnColor.Click
        Dim r, g, b As Byte
        r = Math.Max(0, Math.Min(255, nuColorR.Value))
        g = Math.Max(0, Math.Min(255, nuColorG.Value))
        b = Math.Max(0, Math.Min(255, nuColorB.Value))
        ColorDlg.Color = Color.FromArgb(r, g, b)

        If ColorDlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            nuColorR.Value = ColorDlg.Color.R
            nuColorG.Value = ColorDlg.Color.G
            nuColorB.Value = ColorDlg.Color.B
        End If
    End Sub

    Private Sub LightProps_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown
        Text = "Light $" & Light.ID & " " & Light.Name
        nuRoomID.Value = Light.Room.ID
        nuLocationX.Value = Light.Location.X
        nuLocationY.Value = Light.Location.Y
        nuLocationZ.Value = Light.Location.Z
        nuRadius.Value = Light.Radius
        nuBrightness.Value = Light.Brightness
        nuColorR.Value = Light.Color.X
        nuColorG.Value = Light.Color.Y
        nuColorB.Value = Light.Color.Z
        nuMisc1.Value = Light.Unknown1
        nuMisc2.Value = Light.Unknown2
        Me.Light = Light
    End Sub

    Private Sub LightProps_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Light.Room = Light.Project.GetAsset(nuRoomID.Value)
        Light.Location.X = nuLocationX.Value
        Light.Location.Y = nuLocationY.Value
        Light.Location.Z = nuLocationZ.Value
        Light.Radius = nuRadius.Value
        Light.Brightness = nuBrightness.Value
        Light.Color.X = nuColorR.Value
        Light.Color.Y = nuColorG.Value
        Light.Color.Z = nuColorB.Value
        Light.Unknown1 = nuMisc1.Value
        Light.Unknown2 = nuMisc2.Value
    End Sub

End Class